#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <queue>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <memory.h>
#include <ctime>
#include <bitset>

using namespace std;

#define ABS(a) ((a>0)?a:-(a))
#define MIN(a,b) ((a<b)?(a):(b))
#define MAX(a,b) ((a<b)?(b):(a))
#define FOR(i,a,n) for (int i=(a);i<(n);++i)
#define FI(i,n) for (int i=0; i<(n); ++i)
#define pnt pair <int, int>
#define mp make_pair
#define PI 3.1415926535897
#define MEMS(a,b) memset(a,b,sizeof(a))
#define LL long long
#define U unsigned

int a[110][110];
int cnt[110];
vector<int> all;
int q[1010];
int d[110];

void generateRandomTest(string path)
{
	int n = rand() % 99;
	n += 2;
	int m = rand() % 20; m++;
	FILE *f = fopen(path.c_str(), "w");
	fprintf(f, "%d %d\n", n, m);
	vector<int> perm;
	FOR(i, 0, n)
		perm.push_back(i);
	FOR(i, 0, m)
	{
		int p = rand() % n; p++;
		random_shuffle(perm.begin(), perm.end());
		fprintf(f, "%d", p);
		FOR(j, 0, p)
		{
			fprintf(f, " %d", perm[j] + 1);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "%d %d\n", rand() % n + 1, rand() % n + 1);
}

int main()
{
#ifdef Fcdkbear
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	double beg = clock();
#endif

	int n, m;
	scanf("%d%d", &n, &m);
	FOR(i, 0, m)
	{
		int p;
		scanf("%d", &p);
		all.clear();
		all.resize(p);
		FOR(j, 0, p)
		{
			scanf("%d", &all[j]);
			all[j]--;
			cnt[all[j]]++;
		}
		FOR(j, 0, p)
		{
			FOR(k, j + 1, p)
			{
				a[all[j]][all[k]] = a[all[k]][all[j]] = 1;
			}
		}
	}
	int st, en;
	cin >> st >> en;
	st--;
	en--;
	int l = 500, r = 500;
	q[l] = st;
	FOR(i, 0, n)
		d[i] = 1000000000;
	d[st] = 0;
	while (l <= r)
	{
		int v = q[l];
		l++;
		FOR(i, 0, n)
		{
			if (a[v][i])
			{
				int w = 0;
				if (cnt[i] > 1)
					w = 1;
				if (d[v] + w < d[i])
				{
					if (w == 0)
					{
						l--;
						q[l] = i;
					}
					else
					{
						r++;
						q[r] = i;
					}
					d[i] = d[v] + w;
				}
			}
		}
	}
	int res = d[en];
	if (res == 1000000000)
	{
		cout << -1 << endl;
		return 0;
	}
	if (cnt[en] > 1)
		res--;
	res = MAX(res, 0);
	cout << res << endl;

#ifdef Fcdkbear
	double end = clock();
	fprintf(stderr, "*** Total time = %.3lf ***\n", (end - beg) / CLOCKS_PER_SEC);
#endif
	return 0;
}