// For n \gg m, counts from 1 to m , 

#include <iostream>

using namespace std;

long long calc_in_range(long long start, long long fin_incl, long long m)
{
	long long res = 0LL;
	for(long long i = start; i <= fin_incl; i++)
		res += i*i;
	return res % m;
}

int main(int argc, char* argv[])
{
	long long n, m;
	cin >> n >> m;

	long long res;
	if(n < 2*m)
	{
		res = calc_in_range(1, n, m);
	}
	else
	{
		res = calc_in_range(1, m, m);
		long long num_full_ranges = n / m;
		res *= num_full_ranges;
		res += calc_in_range(1, n%m, m);
		res %= m;
	}
	cout << (m - res) % m << endl;
	return 0;
}

