#include <cstdio>
#include <iostream>
#include <ctime>
#include <algorithm>

using namespace std;

int solve(int b1, int b2, int b3, int z) {
	int a[3] = { b1, b2, b3 };

	sort(a, a + 3);

	int d1 = a[1] - a[0];
	int d2 = a[2] - a[1];

	if (d1 + d2 <= z)  return 0; 
	if (d1 > d2) swap(d1, d2);
	int need = (d1 + d2 - z + 1) / 2;
	if (need <= d1) return need;

	int res = d1;
	d2 -= d1;
	d1 -= d1;
	need = d2 - z;
	res += 2 * (need / 3);
	d2 -= 3 * (need / 3);
	if (z == 0) {
		if (d2 == 0)  return res; 
		else return -1; 
	}
	else return res + d2 - z;
}

int solve2(int b1, int b2, int b3, int z)
{
	long long a[4] = { b1, b2, b3, z };	
	sort(&a[0], &a[3]);
	if (z == 0)
	{
		if ((a[0] + a[1] + a[2]) % 3)
			return -1;
		else
		{
			long long mid = (a[0] + a[1] + a[2]) / 3;
			return (abs(a[0] - mid) + abs(a[1] - mid) + abs(a[2] - mid)) / 2;
		}
	}
	if (a[2] - a[0] <= z)
	{
		return 0;
	}
	long long tz = (a[2] - a[0] - z + 1) / 2;
	long long ta = a[1] - a[0];
	long long tb = a[2] - a[1];
	long long tt = min(ta, tb);
	if (tz <= tt)
	{
		return tz;
	}
	long long D = a[2] - a[0] - 2 * tt - z;
	tt += 2 * (D / 3) + D % 3;
	return tt;	
}

int main() {
	
	int a, b, c, d;
	cin >> a >> b >> c >> d;
	cout << solve2(a, b, c, d) << endl;
	return 0;
	/*srand(time(0));
	for (int i = 0; i < 10000; ++i) {
		//cout << "tst" << i << endl;
		int b1 = (rand() & 1) ? (rand() * (1ll << 30) + rand()) % 1000000000 : rand();
		int b2 = (rand() & 1) ? (rand() * (1ll << 30) + rand()) % 1000000000 : rand();
		int b3 = (rand() & 1) ? (rand() * (1ll << 30) + rand()) % 1000000000 : rand();
		int z = 0;
		{
			int zu = min(abs(b1 - b2), min( abs(b2 - b3), abs(b1 - b3)));
			z = (rand() & 1) ? (rand() * (1ll << 30) + rand()) % 1000000000 : rand();
			z = z % zu;
		}
		int r1 = solve(b1, b2, b3, z);
		int r2 = solve2(b1, b2, b3, z);
		if (r1 != r2) {
			cout << b1 << ' ' << b2 << ' ' << b3 << ' ' << z << endl << r1 << ' ' << r2 << endl;
		}

	}

	return 0;*/
}